program n_subwalk_pingmode;

{$mode objfpc}{$H+}
{$define UseCThreads}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, CustApp
  { you can add units after this }, pingsend, net_threads;

type

  { TMyApplication }

  TMyApplication = class(TCustomApplication)
  protected
    procedure DoRun; override;
  public
    procedure threadterminated(Sender: TObject);
    n_threads: array [1..255] of nThread;
    z: integer;
    hosts: TStringlist;
  end;

{ TMyApplication }

procedure TMyApplication.DoRun;
var host: string;
    tm:   integer;
    I:    integer;
begin
  if ParamStr(1) <> '' then begin
    host := ParamStr(1);
  end
  else begin
    halt;
  end;
  if ParamStr(2) <> '' then begin
    tm   := StrToInt(ParamStr(2));
  end
  else begin
    halt;
  end;

  hosts := TStringlist.Create;
  z := 255;

  for I:=1 to 255 do begin
    n_threads[I]             := nThread.Create(true);
    n_threads[I].host        := host + '.' + inttostr(I);
    n_threads[I].tm          := tm;
    n_threads[I].OnTerminate := @threadterminated;
    n_threads[I].Resume;
  end;
  writeln('schleife vorbei');
  { add your program here }

  // stop program loop
  Terminate;
end;

procedure TMyApplication.threadterminated(Sender: TObject);
begin
 dec(z);
 //writeln(z);
end;

var
  Application: TMyApplication;
begin
  Application:=TMyApplication.Create(nil);
  Application.Run;
  Application.Free;
end.

